.TH "siggen::MTQueue" 3 "Wed Oct 9 2019" "Version 1.0" "SigGen" \" -*- nroff -*-
.ad l
.nh
.SH NAME
siggen::MTQueue \- synchronized data passing between producer and consumer threads  

.SH SYNOPSIS
.br
.PP
.PP
\fC#include <MTQueue\&.h>\fP
.SS "Public Member Functions"

.in +1c
.ti -1c
.RI "\fBMTQueue\fP (size_t n, size_t blockSize)"
.br
.RI "creates queue for n blocks with each block of blockSize bytes "
.ti -1c
.RI "void \fBEnqueue\fP (size_t blockIndex, std::vector< char > &data)"
.br
.RI "enqueues data or waits "
.ti -1c
.RI "void \fBDequeue\fP (size_t &blockIndex, std::vector< char > &data)"
.br
.RI "dequeues data or waits "
.ti -1c
.RI "void \fBTerminate\fP ()"
.br
.RI "sets terminate flag and notify waiting thread(s) "
.in -1c
.SS "Protected Member Functions"

.in +1c
.ti -1c
.RI "bool \fBIsWorkReady\fP () const"
.br
.RI "queue has at least one item "
.ti -1c
.RI "bool \fBIsFull\fP () const"
.br
.RI "queue is full "
.in -1c
.SH "Detailed Description"
.PP 
synchronized data passing between producer and consumer threads 

\fBMTQueue\fP uses classic mutex and condition variables for synchronization\&. \fBMTQueue\fP is pre-allocated to N elements and does not change it's size\&. 
.PP
Definition at line 16 of file MTQueue\&.h\&.
.SH "Constructor & Destructor Documentation"
.PP 
.SS "siggen::MTQueue::MTQueue (size_t n, size_t blockSize)"

.PP
creates queue for n blocks with each block of blockSize bytes 
.PP
\fBParameters\fP
.RS 4
\fIn\fP size of the queue to be pre-allocated for 
.br
\fIblockSize\fP size of each individual block of data
.RE
.PP
the queue will be preallocated to N items, each with blockSize bytes of data 
.PP
Definition at line 7 of file MTQueue\&.cpp\&.
.SH "Member Function Documentation"
.PP 
.SS "void siggen::MTQueue::Dequeue (size_t & blockIndex, std::vector< char > & data)"

.PP
dequeues data or waits 
.PP
\fBParameters\fP
.RS 4
\fIblockIndex\fP index of the block of data to be processed 
.br
\fIdata\fP data corresponding to the index 
.RE
.PP

.PP
Definition at line 42 of file MTQueue\&.cpp\&.
.SS "void siggen::MTQueue::Enqueue (size_t blockIndex, std::vector< char > & data)"

.PP
enqueues data or waits 
.PP
\fBParameters\fP
.RS 4
\fIblockIndex\fP index of the block of data to be processed 
.br
\fIdata\fP data corresponding to the index 
.RE
.PP

.PP
Definition at line 18 of file MTQueue\&.cpp\&.

.SH "Author"
.PP 
Generated automatically by Doxygen for SigGen from the source code\&.
